python - 能源消耗最大化

标签 python algorithm dynamic-programming linear-programming

提供了三种食物,即肉、蛋糕和披萨 和 N 个不同的商店出售它,我只能从中挑选一种食物 每家商店。此外,我只能购买 A、B 和 C 编号的商品,其中“A”表示来自不同商店总数“A”的肉类(参见示例)。我的任务是 消耗食物,这样我才能拥有最大的能量。 例如,

10            <= number of stores <br>
5 3 2         <= out of 10 stores I can pick meat from 5 stores only. Similarly,
                 I can pick cake from 3 out of 10 stores...
56 44 41    1 <= Energy level of meat, cake and pizza - (56, 44, 41) for first store.<br> 
56 84 45    2
40 98 49    3
91 59 73    4
69 94 42    5
81 64 80    6
55 76 26    7
63 24 22    8
81 60 44    9
52 95 11    10

所以为了最大化我的能量,我可以消耗...

  1. 商店编号的肉类:

    [1, 4, 7, 8, 9] => [56, 91, 55, 63, 81]
    
  2. 商店编号的蛋糕:

    [3, 5, 10] => [98, 94, 95]
    
  3. 来自商店号码的披萨:

    [2, 6] => [45, 80]
    

这使我最终获得了 758 的最大能量水平。


因为我是动态规划的新手,所以我尝试通过生成独特的组合来解决它,例如,

10C5 * (10-5)C3 * (10-5 -3)C2 = 2520

这是我的代码,

nStores = 10
a, b, c = 5, 3, 2
matrix = [
    [56,44,41],
    [56,84,45],
    [40,98,49],
    [91,59,73],
    [69,94,42],
    [81,64,80],
    [55,76,26],
    [63,24,22],
    [81,60,44],
    [52,95,11]
]

count = a + b + c
data = []
allOverCount = [i for i in range(count)]
def genCombination(offset, depth, passedData, reductionLevel = 3):
    if (depth == 0):
        first = set(data)
        if reductionLevel ==  3:
            return genCombination(0,b,[i for i in allOverCount if i not in first], reductionLevel=2)
        elif reductionLevel ==  2:
            return genCombination(0,c,[i for i in allOverCount if i not in first], reductionLevel=1)
        elif reductionLevel == 1:
            xAns = 0
            for i in range(len(data)):
                if i < a:
                    xAns += matrix[data[i]][0]
                elif i < a + b:
                    xAns += matrix[data[i]][1]
                else:
                    xAns += matrix[data[i]][2]
            return xAns
    oneData = 0
    for i in range(offset, len(passedData) - depth + 1 ):
        data.append(passedData[i])
        oneData = max(oneData, genCombination(i+1, depth-1, passedData, reductionLevel))
        del data[-1]
    return oneData
passedData = [i for i in range(count)]
finalOutput = genCombination(0,a,passedData)
print(finalOutput)

我知道这不是正确的做法。我该如何优化它?

最佳答案

这是一个通过 pulp ( https://pypi.org/project/PuLP ) 使用线性规划的解决方案,它为我提供了最佳解决方案

Maximum energy level: 758.0
Mapping of stores per foodtype: {1: [9, 2, 4], 0: [3, 8, 0, 6, 7], 2: [1, 5]}

我认为性能应该比手动编码的穷举求解器更好。

from collections import defaultdict

import pulp

# data
nStores = 10
a, b, c = max_stores = 5, 3, 2
matrix = [
    [56, 44, 41],
    [56, 84, 45],
    [40, 98, 49],
    [91, 59, 73],
    [69, 94, 42],
    [81, 64, 80],
    [55, 76, 26],
    [63, 24, 22],
    [81, 60, 44],
    [52, 95, 11]
]

# create an LP problem
lp = pulp.LpProblem("maximize energy", sense=pulp.LpMaximize)

# create the list of indices for the variables
# the variables are binary variables for each combination of store and food_type
# the variable alpha[(store, food_typeà] = 1 if the food_type is taken from the store
index = {(store, food_type) for store in range(nStores) for food_type in range(3)}
alpha = pulp.LpVariable.dicts("alpha", index, lowBound=0, cat="Binary")

# add the constrain on max stores
for food_type, n_store_food_type in enumerate(max_stores):
    lp += sum(alpha[(store, food_type)] for store in range(nStores)) <= n_store_food_type

# only one food type can be taken per store
for store in range(nStores):
    lp += sum(alpha[(store, food_type)] for food_type in range(3)) <= 1

# add the objective to maximise
lp += sum(alpha[(store, food_type)] * matrix[store][food_type] for store, food_type in index)

# solve the problem
lp.solve()

# collect the results
stores_for_foodtype = defaultdict(list)
for (store, food_type) in index:
    # check if the variable is active
    if alpha[(store, food_type)].varValue:
        stores_for_foodtype[food_type].append(store)

print(f"Maximum energy level: {lp.objective.value()}")
print(f"Mapping of stores per foodtype: {dict(stores_for_foodtype)}")

关于python - 能源消耗最大化,我们在Stack Overflow上找到一个类似的问题: https://stackoverflow.com/questions/55444338/

相关文章:

java - myhashmap 扩展 hashmap 并覆盖哈希函数

c++ - RobuSTLy 找到 N 个直径相同的圆 : alternative to bruteforcing Hough transform threshold

javascript - 重复子数组的最大长度(leetcode)

python - 使用Python将图像转换为十六进制格式

python - 从多维数组中选择一个数组

java - 计算多条鱼的时空复杂度?

c++ - 字符串比较的动态编程

c - SPOJ COINS DP 和递归方法

python - 使用 urllib 检索所有 header 数据

python - 在heroku-18堆栈上部署python 3.6.5 Django应用程序